local Room = Gamestate.new();

	function Room:reset()
		Room.img = love.graphics.newImage("img/rooms/control/fondoD.png");
		Room.console = {}
			Room.console[0] = Switch(); Room.console[0].on = false;
			Room.console[1] = Switch(35,500,5);
			Room.console[2] = Switch(95,500,7);
			Room.console[3] = Switch(155,500,9);
			Room.console[4] = Switch(215,500,12);
		Room.obstaculos = {}
			table.insert(Room.obstaculos,{x=0,y=580,width=900,height=20});
			table.insert(Room.obstaculos,{x=0,y=0,width=25,height=600});
			table.insert(Room.obstaculos,{x=776,y=0,width=25,height=600});
		Room.doors = {};
			table.insert(Room.doors,{x=355,y=480,width=90,height=100,open=function() STATES.current = STATES.room2; Gamestate.switch(STATES.current); PERSONAJE.position.x = 113; PERSONAJE.position.y = 296-64 end});
		Room.lift = false;
	end
	
	function Room:enter()
		SND.HORN:setVolume(0.05);
	end

	function Room:draw()
		love.graphics.draw(self.img,0,0);
		love.graphics.draw(IMG.ALERT,70,370,math.rad(-15),0.5);	--love.graphics.print("DO NOT DEACTIVATE!",70,400,math.rad(-15));
		love.graphics.draw(IMG.CONSOLE,25,480);	--love.graphics.rectangle("line",25,480,250,100);--console
		for i=1,#self.console do
			local b = self.console[i];
			--love.graphics.rectangle("line",b.x,b.y,b.width,b.height);
			if b.on then
				--love.graphics.setColor(0,255,0);
				--love.graphics.print("switch \nON",b.x,b.y);
				love.graphics.setColor(255,255,255);
				love.graphics.draw(IMG.SWITCH_ON,b.x,b.y);
			else
				--love.graphics.setColor(255,0,0);
				--love.graphics.print("switch \nOFF",b.x,b.y);
				love.graphics.setColor(255,255,255);
				love.graphics.draw(IMG.SWITCH_OFF,b.x,b.y);
			end
			love.graphics.setColor(255,255,255);
		end
		if STATES.room4.siren then
			--love.graphics.rectangle("line",50,430,200,50); love.graphics.print("ALARM SYSTEM",100,450);
			love.graphics.draw(IMG.PANEL_ON,50,430);
		else
			love.graphics.draw(IMG.PANEL_OFF,50,430);
		end

		--[[for i=1,#self.obstaculos do
			local o = self.obstaculos[i];
			love.graphics.rectangle("line",o.x,o.y,o.width,o.height);
		end]]
		love.graphics.draw(IMG.TUBE_Y,0,0);
		love.graphics.draw(IMG.TUBE_Y,776,0);
		love.graphics.draw(IMG.TUBE_X,0,580);
		--[[for i=1,#self.doors do
			local d = self.doors[i];
			love.graphics.rectangle("line",d.x,d.y,d.width,d.height);
			love.graphics.print("door",d.x,d.y);
		end]]
		PERSONAJE:draw();
	end

	function Room:update(dt)
		PERSONAJE:update(dt);
	end

	function Room:mousepressed(x,y,button)
		if button=="l" then
			for i=1,#self.console do
				local b = self.console[i];
				if CheckCollision(x,y,1,1, b.x,b.y,b.width,b.height)then
					if not self.console[i-1].on then 
						b.go();
						SND.SWITCH.TRY:stop();
						SND.SWITCH.TRY:play();
					else
						SND.SWITCH.CANT:stop();
						SND.SWITCH.CANT:play();
					end
				end
			end
		end
	end

return Room;
