local Personaje = {};
	
	function Personaje:reset()
		self.img = IMG.CHAR;
		self.width = self.img:getWidth(); self.height = self.img:getHeight();
		self.position = {x=200,y=516};	self.positionold = {}; self.positionnew = {};
		self.velocity = {x=0,y=0};
		self.velx = 0.1;			--0.01
		self.vely = 0.25;			--0.015
		self.max_x_velocity = 2.9;	--0.7
		self.max_y_velocity = 7.5;	--1.5
		self.dir = 1; -- [1/-1]
		self.estado = 0;		--[0 cayendo / 1 caminando / 2 saltando]
		self.ALIVE = true;	self.DEADTIME = 0;

		self.up = false;
	end
	
	function Personaje:draw()
		if self.ALIVE then
			if self.dir>0 then
				love.graphics.draw(self.img,self.position.x,self.position.y,0);
			else
				love.graphics.draw(self.img,self.position.x,self.position.y,0,-1,1,self.width,0);
			end
		else
			if self.dir>0 then
				love.graphics.draw(IMG.SQUELETON,self.position.x,self.position.y+44,0);
			else
				love.graphics.draw(IMG.SQUELETON,self.position.x,self.position.y+44,0,-1,1,self.width,0);
			end
		end
		-- love.graphics.rectangle("line",self.position.x,self.position.y,self.width,self.height);
		-- love.graphics.print(self.position.x,10,25); love.graphics.print(self.velocity.x,120,25);
		-- love.graphics.print(self.position.y,10,40); love.graphics.print(self.velocity.y,120,40);
	end
	
	function Personaje:update(dt)
		if self.ALIVE then
			if STATES.current.lift and STATES.current.lift.estado~=0 then return; end
			--	velocidad
			if love.keyboard.isDown("left")and not love.keyboard.isDown("right")then
				self.velocity.x = self.velocity.x - self.velx;
				self.velocity.x = math.max(self.velocity.x,-self.max_x_velocity);
				self.dir = -1;
			end
			if not love.keyboard.isDown("left")and love.keyboard.isDown("right")then
				self.velocity.x = self.velocity.x + self.velx;
				self.velocity.x = math.min(self.velocity.x,self.max_x_velocity);
				self.dir = 1;
			end
			if not love.keyboard.isDown("left")and not love.keyboard.isDown("right")then
				self.velocity.x = self.velocity.x * 0.9;
				if math.abs(self.velocity.x) < 0.5 then self.velocity.x = 0; --[[self.position.x = math.ceil(self.position.x);]] end
			end
			
	--		if love.keyboard.isDown("up") and self.estado==1 then
	--			self.velocity.y = -self.vely*20;
	--			self.estado = 2;
	--		end
			
			--gravedad
			self.velocity.y = self.velocity.y + self.vely;
			self.velocity.y = math.min(self.velocity.y,self.max_y_velocity);
			if self.estado==2 and self.velocity.y == 0 then self.estado=0 end
			
			
			--	mov horizontal
			local antes = self.position.x;
			self.position.x = self.position.x + self.velocity.x;
			local despues = self.position.x;
			if despues-antes>0 then -- se movio a der
				for i=1,#STATES.current.obstaculos do
					local r = STATES.current.obstaculos[i];
					if CheckCollision(self.position.x,self.position.y,self.width,self.height,r.x,r.y,r.width,r.height)then
						self.position.x = r.x - self.width - self.velx;
						self.velocity.x = 0;
					end
				end
			elseif despues-antes<0 then --se movio a izq
				for i=1,#STATES.current.obstaculos do
					local r = STATES.current.obstaculos[i];
					if CheckCollision(self.position.x,self.position.y,self.width,self.height,r.x,r.y,r.width,r.height)then
						self.position.x = r.x + r.width + self.velx;
						self.velocity.x = 0;
					end
				end
			end
			
			--	mov vertical
			local antesy = self.position.y;
			self.position.y = self.position.y + self.velocity.y;
			local despuesy = self.position.y;
			if despuesy-antesy>0 then	-- se movio abajo
				for i=1,#STATES.current.obstaculos do
					local r = STATES.current.obstaculos[i];
					if CheckCollision(self.position.x,self.position.y,self.width,self.height,r.x,r.y,r.width,r.height)then
						self.position.y = r.y - self.height - self.vely;
						self.velocity.y = 0;
						self.estado = 1;
					end
				end
			elseif despuesy-antesy<0 then	-- se movio arriba
				for i=1,#STATES.current.obstaculos do
					local r = STATES.current.obstaculos[i];
					if CheckCollision(self.position.x,self.position.y,self.width,self.height,r.x,r.y,r.width,r.height)then
						self.position.y = r.y + r.height + self.vely;
						self.velocity.y = 0;
						self.estado = 0;
					end
				end
			end

			if love.keyboard.isDown("up") then
				if not self.up then
					self.up = true;
					for i=1,#STATES.current.doors do
						local d = STATES.current.doors[i];
						if CheckContains(self.position.x,self.position.y,self.width,self.height, d.x,d.y,d.width,d.height)then
							if not d.open then
								local r = math.random(1,3);
								SND.DOOR.CLOSED[r]:stop();
								SND.DOOR.CLOSED[r]:play();
							else
								d.open();
							end
						end
					end
				end
			else
				self.up = false;
			end
		else --IS NOT ALIVE
			self.DEADTIME = self.DEADTIME - 1;
			if self.DEADTIME == 0 then
				INIT();
			end
		end
	end

	function Personaje:die()
		self.ALIVE = false;
		self.DEADTIME = 200;
		SND.DIE:stop();
		SND.DIE:play();
	end

return Personaje;
