local Room = Gamestate.new();

	function Room:reset()
		Room.fondo = love.graphics.newImage("img/rooms/4/room4.png");
		Room.obstaculos = {}
			table.insert(Room.obstaculos,{x=0,y=580,width=900,height=20});
			table.insert(Room.obstaculos,{x=0,y=0,width=25,height=600});
		Room.doors = {}
			table.insert(Room.doors,{x=104,y=484,width=76,height=96,open=function() self:ENDGAME();end});
		Room.lift = false;
		Room.siren = true;

		Room.gas = love.graphics.newParticleSystem(love.graphics.newImage("img/particle.png"),100);
		Room.gas:setEmissionRate          (50)
		-- Room.gas:setLifetime              (0.1)
		Room.gas:setParticleLifetime         (2.5)
		-- Room.gas:setPosition              (0, 0)
		Room.gas:setDirection             ((90*math.pi)/180)
		Room.gas:setSpread                (200)
		Room.gas:setSpeed                 (10,0)
		Room.gas:setLinearAcceleration    (0,0,0-20)
		Room.gas:setRadialAcceleration    (0)
		Room.gas:setTangentialAcceleration(0)
		Room.gas:setSizes                 (2)
		Room.gas:setSizeVariation         (1)--50.7
		Room.gas:setRotation              (0)
		Room.gas:setSpin                  (0)
		Room.gas:setSpinVariation         (0)
		Room.gas:setColors               (155, 155, 155, 10,155,155,155,100,155,155,155,0)
		Room.gas:start();
	end

	function Room:enter()
		SND.HORN:setVolume(0.8);
		self.cont = 0;
	end

	function Room:draw()
		love.graphics.draw(Room.fondo,0,0);
		PERSONAJE:draw();
		--obstaculos
		-- for i=1,#self.obstaculos do
		-- 	local r = self.obstaculos[i];
		-- 	love.graphics.rectangle("line",r.x,r.y,r.width,r.height);
		-- end
		-- --puertas
		-- for i=1,#self.doors do
		-- 	local d = self.doors[i];
		-- 	love.graphics.rectangle("line",d.x,d.y,d.width,d.height);
		-- end
		love.graphics.draw(self.gas);
	end

	function Room:update(dt)
		PERSONAJE:update(dt);
		if PERSONAJE.position.x > 820 then
			STATES.current = STATES.room3;
			Gamestate.switch(STATES.current);
			PERSONAJE.position.x = -64;
			PERSONAJE.position.y = PERSONAJE.position.y;
			PERSONAJE.velocity.x = PERSONAJE.velocity.x;
			PERSONAJE.velocity.y = PERSONAJE.velocity.y;
		end
		if self.siren then
			self.cont = self.cont + 1;
			if self.cont > 200 and PERSONAJE.ALIVE and STATES.current==self then
				PERSONAJE:die();
			end
		end
		self.gas:setPosition(math.random(0,800),600);
		self.gas:update(dt);
	end

	function Room:desactivarSirena()
		self.siren = false;
		self.gas:stop();
		SND.HORN:stop();
	end

	function Room:ENDGAME()
		STATES.current = STATES.EndRoom;
		Gamestate.switch(STATES.current);
	end

return Room;
