local Simon = Gamestate.new();

	function Simon:reset()
		Simon.NIVEL = 5; --5 facil, 7 medio, 10 avanzado, >10 dificil

		Simon.circle = {
			x=400, y=300,
			radio=200
		}

		Simon.notas={}
		Simon.notas[1] = {nombre="C"};
		Simon.notas[2] = {nombre="C#"};
		Simon.notas[3] = {nombre="D"};
		Simon.notas[4] = {nombre="D#"};
		Simon.notas[5] = {nombre="E"};
		Simon.notas[6] = {nombre="F"};
		Simon.notas[7] = {nombre="F#"};
		Simon.notas[8] = {nombre="G"};
		Simon.notas[9] = {nombre="G#"};
		Simon.notas[10] = {nombre="A"};
		Simon.notas[11] = {nombre="A#"};
		Simon.notas[12] = {nombre="B"};
		for i=1,12 do
			local t = 2*math.pi*i/#Simon.notas;
			Simon.notas[i].x = Simon.circle.x + math.cos(t)*Simon.circle.radio;
			Simon.notas[i].y = Simon.circle.y +math.sin(t)*Simon.circle.radio;
			Simon.notas[i].radioMIN = 20;
			Simon.notas[i].radio = Simon.notas[i].radioMIN;
		end
	end
	
	function Simon:enter()
		self.CAMERA = Camera(800/2,600/2);
		for i=1,12 do Simon.notas[i].radio = Simon.notas[i].radioMIN; end
		Simon.keys = {}
			for i=1,Simon.NIVEL do
				repeat
					Simon.keys[i] = math.random(1,12);
					local ok = true;
					for j=1,i-1 do
						if Simon.keys[i]==Simon.keys[j] then
							ok = false;
							break;
						end
					end
				until ok==true;
				-- print(Simon.keys[i]);
			end
		Simon.currentKey = 1;
		Simon.currentKey2 = 1;

		--	TURNOS
		Simon.turno = 0;--[0 PC/1 player]
		Simon.timeOffsetMAX = 50;
		Simon.timeOffset = Simon.timeOffsetMAX;
		Simon.timeBetweenNotesMAX = 40;
		Simon.timeBetweenNotes = Simon.timeBetweenNotesMAX;

		Simon.win = false;

		Simon.pol = {};
	end

	function Simon:draw()
		self.CAMERA:attach();
		-- if Simon.turno==0 then love.graphics.setColor(255,0,0);
		-- else love.graphics.setColor(0,255,0); end
		-- love.graphics.rectangle("fill",0,0,800,600);
		-- love.graphics.setColor(255,255,255);
		for i=1,#Simon.pol do
			local k = Simon.pol[i];
			love.graphics.line(k.x,k.y,k.x2,k.y2);
		end
		for i=1,12 do
			love.graphics.circle("fill",Simon.notas[i].x,Simon.notas[i].y,Simon.notas[i].radio);
			-- love.graphics.setColor(0,0,0);
			-- love.graphics.print(Simon.notas[i].nombre,Simon.notas[i].x-5,Simon.notas[i].y-5);
			-- love.graphics.setColor(255,255,255);
		end
		self.CAMERA:detach();
		--love.graphics.print("NIVEL "..Simon.NIVEL,10,25);
	end

	function Simon:update(dt)
		for i=1,12 do if Simon.notas[i].radio > Simon.notas[i].radioMIN then Simon.notas[i].radio = Simon.notas[i].radio-1; end	end

		--juego
		if not Simon.win then
			Simon:jugar();
		else
			STATES.current = STATES.control;
			self.triggeredSwitch.on = false;
			Gamestate.switch(STATES.current);
			SND.SWITCH.OFF:stop();
			SND.SWITCH.OFF:play();
			if 	not	STATES.control.console[1].on and
				not	STATES.control.console[2].on and
				not	STATES.control.console[3].on and
				not	STATES.control.console[4].on then
				STATES.room4:desactivarSirena();
			end
		end
		self.CAMERA:rotate(0.0005*self.currentKey);
	end

	function Simon:keypressed(key,unicode)
		if key=="escape" then 
			STATES.current = STATES.control;
			Gamestate.switch(STATES.current);
			SND.CANCEL:stop();
			SND.CANCEL:play();
		end
	end

	function Simon:mousepressed(x,y,button)
		x,y = self.CAMERA:mousepos();
		if Simon.turno == 1 then
			for i=1,12 do
				local c = Simon.notas[i];
				if CheckCollision(x,y,1,1, c.x-c.radio,c.y-c.radio,c.radio*2,c.radio*2) then
					self:tocarBell(i);
				end
			end
		end
	end

	function Simon:jugar()
		if Simon.turno == 0 then
			if Simon.timeOffset > 0 then Simon.timeOffset = Simon.timeOffset-1;
			else
				if Simon.currentKey <= Simon.NIVEL then
					if Simon.currentKey2 <= Simon.currentKey then
						if Simon.timeBetweenNotes > 0  then Simon.timeBetweenNotes = Simon.timeBetweenNotes - 1;
						else
							SND.BELL[Simon.keys[Simon.currentKey2]]:stop(); SND.BELL[Simon.keys[Simon.currentKey2]]:play();
							Simon.notas[Simon.keys[Simon.currentKey2]].radio = 50;
							Simon.currentKey2 = Simon.currentKey2 + 1;
							Simon.timeBetweenNotes = Simon.timeBetweenNotesMAX;
						end
					else
						Simon.currentKey = Simon.currentKey + 1;
						Simon:cambiarTurnoA(1);
					end
				else
					Simon.win = true;
				end
			end
		end
	end

	function Simon:tocarBell(i)
		SND.BELL[i]:stop(); SND.BELL[i]:play();
		Simon.notas[i].radio = 50;

		if i==Simon.keys[Simon.currentKey2] then --lo hizo bien
			Simon.currentKey2 = Simon.currentKey2 + 1;
			if Simon.currentKey2>2 then 
				local este = Simon.notas[Simon.keys[Simon.currentKey2-1]];
				local anterior = Simon.notas[Simon.keys[Simon.currentKey2-1-1]];
				table.insert(Simon.pol,{x=este.x,y=este.y,x2=anterior.x,y2=anterior.y});
				-- if este~=anterior then
				-- 	SND.AVANCE:stop();
				-- 	SND.AVANCE:play();
				-- end
			end
		else --se equivoco
			SND.WRONG:stop(); SND.WRONG:play(); 
			Simon.currentKey = 1; Simon:cambiarTurnoA(0); 
			Simon.pol = {}
		end
		if Simon.currentKey2 == Simon.currentKey then
			Simon:cambiarTurnoA(0);
		end
	end

	function Simon:cambiarTurnoA(t)
		Simon.turno = t;
		Simon.timeOffset = Simon.timeOffsetMAX;
		Simon.currentKey2 = 1;
		Simon.timeBetweenNotes = Simon.timeBetweenNotesMAX;
	end

return Simon;
